#include <math.h>
/************************************************************
			SISO23_4_pun_Outer
************************************************************/
void SISO23_4_pun_Outer(const int nsteps, int* llri, int* llro)
{
/* Allocate constants */
const static int ini         = -100000;
const static int update_wind = 8000;
const static int train_wind  = 30;
const static int end_steps   = 2;

/* Allocate variables */
static  int n,n_winds,last_wind;
static  int istat,istep,istp,curr_wind;
static  int temp1,temp2;
static  int x0,x1,x2,x3;
static  int olda,newa,nnn;
static  int gmo1,gmo2,gmo3;
static  int alfa[4][2];
static  int beta[4][8030];
static  int nst,tn;
static  int xt;

static  int* llrot;
static  int* llrit;

n=(nsteps-train_wind)%update_wind;
if(n==0)
{
	n_winds = (nsteps-train_wind)/update_wind;
   last_wind =  update_wind+train_wind;
}
else
{
	n_winds = (nsteps-train_wind)/update_wind+1;
   last_wind =  n+train_wind;
}

nst  = update_wind+train_wind;
newa=1;
olda=0;

/* Initialization of ALFA (Identity state) */
alfa[0][olda]=0;
alfa[1][olda]=ini;
alfa[2][olda]=ini;
alfa[3][olda]=ini;


/**** Cycle for sliding Curr_wind *******************/

for(curr_wind=0;curr_wind<n_winds;curr_wind++)
	{

	if(curr_wind==(n_winds-1))nst=last_wind;

  /* Pointer to current wind */
	llrot  = llro  + curr_wind*update_wind*2;
	llrit  = llri  + curr_wind*update_wind;

/* Initialization of BETA */

	beta[0][nst-1]=ini;
	beta[1][nst-1]=ini;
	beta[2][nst-1]=ini;
	beta[3][nst-1]=ini;

	if(curr_wind==(n_winds-1))beta[0][nst-1]=0;

/* BETA recursion */
	for(istep=nst-1;istep>0;istep--)
	{
		if(istep%2==0)
		{
			gmo1  = llrot[(istep/2)*3];
			gmo2  = llrot[(istep/2)*3+1];
		}
		else
		{
			gmo1  = llrot[(istep/2)*3+2];
			gmo2  = 0;
		}
		gmo3  = gmo1+gmo2;

/* ACS */
		temp1            =      beta[0][istep];
		temp2            = gmo3+beta[1][istep];
		beta[0][istep-1] = eopq(temp1,temp2);

		temp1            = gmo2+beta[3][istep];
		temp2            = gmo1+beta[2][istep];
		beta[1][istep-1] = eopq(temp1,temp2);

		temp1            =      beta[1][istep];
		temp2            = gmo3+beta[0][istep];
		beta[2][istep-1] = eopq(temp1,temp2);

		temp1            = gmo2+beta[2][istep];
		temp2            = gmo1+beta[3][istep];
		beta[3][istep-1] = eopq(temp1,temp2);
	}
	
	
/*** Update ALFAs and compute LLRs: ****/
		istp=update_wind;
		if(curr_wind==n_winds-1)istp=nst;
		for(istep=0;istep<istp;istep++)
		{
			if(istep%2==0)
			{
				gmo1  = llrot[(istep/2)*3];
				gmo2  = llrot[(istep/2)*3+1];
			}
			else
			{
				gmo1  = llrot[(istep/2)*3+2];
				gmo2  = 0;
			}
			gmo3  = gmo1+gmo2;

			temp1         =       alfa[0][olda];
			temp2         = gmo3 +alfa[2][olda];
			alfa[0][newa] = eopq(temp1,temp2);

			x0			     = temp1+beta[0][istep];
			x3			     = temp2+beta[0][istep];

			temp1         =       alfa[2][olda];
			temp2         = gmo3 +alfa[0][olda];
			alfa[1][newa] = eopq(temp1,temp2);

			x0				  = eopq(x0,temp1+beta[1][istep]);
			x3				  = eopq(x3,temp2+beta[1][istep]);

			temp1         = gmo2 +alfa[3][olda];
			temp2         = gmo1 +alfa[1][olda];
			alfa[2][newa] = eopq(temp1,temp2);

			x2				  = temp1+beta[2][istep];
			x1				  = temp2+beta[2][istep];

			temp1         = gmo2 +alfa[1][olda];
			temp2         = gmo1 +alfa[3][olda];
			alfa[3][newa] = eopq(temp1,temp2);

			x2				  = eopq(x2,temp1+beta[3][istep]);
			x1				  = eopq(x1,temp2+beta[3][istep]);

		   if(istep%2==0)
			{
				xt = eopq(x3,x1)-eopq(x2,x0)-gmo1;
				llrot[(istep/2)*3]   = xt;

				xt = eopq(x3,x2)-eopq(x1,x0)-gmo2;
				llrot[(istep/2)*3+1] = xt;

				if(curr_wind*update_wind+istep < nsteps-end_steps)
				llrit[istep]=llrot[(istep/2)*3]+gmo1;
			}
			else
			{
				xt = eopq(x3,x1)-eopq(x2,x0)-gmo1;
 			   llrot[(istep/2)*3+2] = xt;
		      if(curr_wind*update_wind+istep < nsteps-end_steps)
				llrit[istep]=llrot[(istep/2)*3+2]+gmo1;
			}


			nnn =olda;
			olda=newa;
			newa=nnn;
		}
	}
}
