#include <stdio.h>
#include <math.h>
//include "lee3c.h"

struct CHANNEL fade_lee(long sample)
{
  long n;
  double T;
  struct CHANNEL ch;
  /* Channel tap 1 */
  ch.Re1=0.0;
  ch.Im1=0.0;
  T=sample*dt_s+1.0;
  for (n=0;n<N; n++)
  {
    ch.Re1 += R[0][n]*cos( f_Hz*T*O[0][n] ) + S[0][n]*sin( f_Hz*T*O[0][n] );
    ch.Im1 += S[0][n]*cos( f_Hz*T*O[0][n] ) - R[0][n]*sin( f_Hz*T*O[0][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re1 *= ChannelTap[0]/sqrt(2.0*N);
  ch.Im1 *= ChannelTap[0]/sqrt(2.0*N);

  /* Channel tap 2 */
  ch.Re2=0.0;
  ch.Im2=0.0;
  T=sample*dt_s+2.0;
  for (n=0;n<N; n++)
  {
    ch.Re2 += R[1][n]*cos( f_Hz*T*O[1][n] ) + S[1][n]*sin( f_Hz*T*O[1][n] );
    ch.Im2 += S[1][n]*cos( f_Hz*T*O[1][n] ) - R[1][n]*sin( f_Hz*T*O[1][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re2 *= ChannelTap[1]/sqrt(2.0*N);
  ch.Im2 *= ChannelTap[1]/sqrt(2.0*N);

  /* Channel tap 3 */
  ch.Re3=0.0;
  ch.Im3=0.0;
  T=sample*dt_s+3.0;
  for (n=0;n<N; n++)
  {
    ch.Re3 += R[2][n]*cos( f_Hz*T*O[2][n] ) + S[2][n]*sin( f_Hz*T*O[2][n] );
    ch.Im3 += S[2][n]*cos( f_Hz*T*O[2][n] ) - R[2][n]*sin( f_Hz*T*O[2][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re3 *= ChannelTap[2]/sqrt(2.0*N);
  ch.Im3 *= ChannelTap[2]/sqrt(2.0*N);

  /* Channel tap 4 */
  ch.Re4=0.0;
  ch.Im4=0.0;
  T=sample*dt_s+4.0;
  for (n=0;n<N; n++)
  {
    ch.Re4 += R[3][n]*cos( f_Hz*T*O[3][n] ) + S[3][n]*sin( f_Hz*T*O[3][n] );
    ch.Im4 += S[3][n]*cos( f_Hz*T*O[3][n] ) - R[3][n]*sin( f_Hz*T*O[3][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re4 *= ChannelTap[3]/sqrt(2.0*N);
  ch.Im4 *= ChannelTap[3]/sqrt(2.0*N);

  /* Channel tap 5 */
  ch.Re5=0.0;
  ch.Im5=0.0;
  T=sample*dt_s+5.0;
  for (n=0;n<N; n++)
  {
    ch.Re5 += R[4][n]*cos( f_Hz*T*O[4][n] ) + S[4][n]*sin( f_Hz*T*O[4][n] );
    ch.Im5 += S[4][n]*cos( f_Hz*T*O[4][n] ) - R[4][n]*sin( f_Hz*T*O[4][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re5 *= ChannelTap[4]/sqrt(2.0*N);
  ch.Im5 *= ChannelTap[4]/sqrt(2.0*N);

  /* Channel tap 6 */
  ch.Re6=0.0;
  ch.Im6=0.0;
  T=sample*dt_s+6.0;
  for (n=0;n<N; n++)
  {
    ch.Re6 += R[5][n]*cos( f_Hz*T*O[5][n] ) + S[5][n]*sin( f_Hz*T*O[5][n] );
    ch.Im6 += S[5][n]*cos( f_Hz*T*O[5][n] ) - R[5][n]*sin( f_Hz*T*O[5][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re6 *= ChannelTap[5]/sqrt(2.0*N);
  ch.Im6 *= ChannelTap[5]/sqrt(2.0*N);

  /* Channel tap 7 */
  ch.Re7=0.0;
  ch.Im7=0.0;
  T=sample*dt_s+7.0;
  for (n=0;n<N; n++)
  {
    ch.Re7 += R[6][n]*cos( f_Hz*T*O[6][n] ) + S[6][n]*sin( f_Hz*T*O[6][n] );
    ch.Im7 += S[6][n]*cos( f_Hz*T*O[6][n] ) - R[6][n]*sin( f_Hz*T*O[6][n] );      
  }
    
  /* Scale channel tap power to one */
  ch.Re7 *= ChannelTap[6]/sqrt(2.0*N);
  ch.Im7 *= ChannelTap[6]/sqrt(2.0*N);
  
  return(ch);
}

void load_lee()
{
  FILE *fp;
  double temp;
  long tap;
  
  /* open file lee.dat for reading */
  printf("Opening lee.dat file for read.\n");
  fp=fopen("Data/lee.dat","rb");
  if (fp==NULL)
  {
    printf("Error in opening file.\n");
    return;
  }

  /* Read first R */
  fread(*R,sizeof(float),ChannelNum*N,fp);
  /* Read second S */
  fread(*S,sizeof(float),ChannelNum*N,fp); 
  /* Read third O */
  fread(*O,sizeof(float),ChannelNum*N,fp); 



  /* close opened file */
  printf("Closing lee.dat file.\n");
  fclose(fp);
  
  
  /* Calculate power scaling factor - scaling channel taps to 1.0 */
  for (temp=0.0,tap=0;tap<ChannelNum;tap++)
    temp += pow(10.0,ChannelTap_dB[tap]/10.0);
    
  /* ChannelTaps to linear scale */
  for (tap=0;tap<ChannelNum;tap++)
    ChannelTap[tap]=pow(10.0,ChannelTap_dB[tap]/20.0)/sqrt(temp);
}

